//  ANO PO "KSI", 2016

#include "CreateHashWindow.h"

CreateHashWindow::CreateHashWindow(QWidget *parent /*= nullptr*/)	:
	QProgressDialog(parent)
{
	setWindowModality(Qt::ApplicationModal);
	setWindowTitle(tr("Hash calculation"));
	QProgressBar* pBar = new QProgressBar;
	pBar->setFormat("%v / %m");
	setBar(pBar);

	connect(this, &QProgressDialog::canceled, this, &CreateHashWindow::cancel);
}

CreateHashWindow::~CreateHashWindow()
{

}

void CreateHashWindow::start(int totalFiles)
{
	m_filesCount = 0;
	setStatus(Status::PROCESSING);
	setValue(0);
	setMaximum(totalFiles);
}

void CreateHashWindow::complete()
{
	setStatus(Status::FINISHED);
	
	reset();
}

void CreateHashWindow::setCurrentFile(const QString& filename)
{
	setLabelText(tr("Processing ")+QString("%1").arg(filename));
	setValue(m_filesCount++);
	qApp->processEvents();
}

void CreateHashWindow::setError(const QString& errDescr)
{
	QMessageBox::critical(this, tr("Error"), errDescr);
	setStatus(Status::ERROR);

	reset();
}

bool CreateHashWindow::wasCancelled() const
{
	return QProgressDialog::wasCanceled();
}

void CreateHashWindow::cancel()
{
	setStatus(Status::INTERRUPTED);

	QMessageBox::warning(this, tr("Abort"), tr("Interrupted by user"));

	QProgressDialog::cancel();
}

bool CreateHashWindow::successfullyompleted() const
{
	return status() == Status::FINISHED;
}
