// © ANO PO "KSI", 2016

#include "DBHashWidget.h"

DBHashWidget::DBHashWidget(const QString& filename, const QString& hash, QWidget *parent)
	: QWidget(parent)
{
	createControls();

	setFilename(filename);
	setHash(hash);	
}

DBHashWidget::~DBHashWidget()
{

}

void DBHashWidget::setFilename(const QString& filename)
{
	m_pLabelFilename->setText(filename);
}

void DBHashWidget::setHash(const QString& hash)
{
	m_pLabelHash->setText(hash);
}

void DBHashWidget::createControls()
{
	QPushButton* pButtonCopy = new QPushButton(QIcon(":/icons/copy.png"),tr("Copy"));
	pButtonCopy->setToolTip(tr("Copy to clipboard"));
	pButtonCopy->setFixedSize(pButtonCopy->minimumSizeHint());

	QBoxLayout* pLayoutHash = new QHBoxLayout;
	pLayoutHash->addWidget(m_pLabelHash = new QLabel);
	pLayoutHash->addWidget(pButtonCopy);
	pLayoutHash->addStretch(0);

	QFormLayout* pLayoutLabels = new QFormLayout;
	pLayoutLabels->addRow(tr("File:"), m_pLabelFilename = new QLabel);
	pLayoutLabels->addRow(tr("Hash:"), pLayoutHash);	

	pLayoutLabels->setMargin(0);

	setLayout(pLayoutLabels);

	connect(pButtonCopy, &QPushButton::clicked, this, &DBHashWidget::copyHashToClipboard);
}

void DBHashWidget::copyHashToClipboard()
{
	QApplication::clipboard()->setText(m_pLabelHash->text());
}
